/* ***** BEGIN LICENSE BLOCK *****
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42)::
 * <qfactor2013 (Live in Seoul, South Korea)> wrote this file.  
 * As long as you retain this notice you can do whatever you want with this stuff. 
 * If we meet some day, and you think this stuff is worth it, 
 * you can buy me a beer and potato chips(love fried potato and sausage) in return. 
 * ----------------------------------------------------------------------------
 * ***** END LICENSE BLOCK ***** */

 /* global XLSX, chrome, JSZip, KWAX*/
(function (global) {
    "use strict";

    global.KWAX = global.KWAX || {};

    KWAX = global.KWAX;

    global.dataURI = global.dataURI || '';

    dataURI = global.dataURI;

    global.zip = global.zip || undefined;

    const title = [];

    KWAX.button = {



        
        disableCssBtn: function (rdoc) {
            var $disableCssBtn = rdoc.createElement('img');
            $disableCssBtn.setAttribute('id', 'disableCss');
            $disableCssBtn.setAttribute('src', "" + chrome.extension.getURL('/images/enable-css-icon.png') + "");
            $disableCssBtn.className = 'disableCss';
            $disableCssBtn.title = global.achecker.i18n.get("disableCSSButtonDesc");
            $disableCssBtn.alt = global.achecker.i18n.get("disableCSSButtonDesc");

            $disableCssBtn.onclick = function () {
                let styleSheets = document.styleSheets;

                for (let i = 0; i < styleSheets.length; i++) {
                    if (styleSheets[i].disabled === false) {
                        styleSheets[i].disabled = true;
                        $disableCssBtn.src = "" + chrome.extension.getURL('/images/disable-css-icon.png') + ""
                        $disableCssBtn.title = global.achecker.i18n.get("enableCSSButtonDesc");
                        $disableCssBtn.alt = global.achecker.i18n.get("enableCSSButtonDesc");
                    } else {
                        styleSheets[i].disabled = false;
                        $disableCssBtn.src = "" + chrome.extension.getURL('/images/enable-css-icon.png') + ""
                        $disableCssBtn.title = global.achecker.i18n.get("disableCSSButtonDesc");
                        $disableCssBtn.alt = global.achecker.i18n.get("disableCSSButtonDesc");
                    }
                }
            }
            return $disableCssBtn;
        },

        backgroundGrayBtn: function (rdoc) {
            var $grayButton = rdoc.createElement('button');
            $grayButton.title = 'Click to Html Background Color Gray';
            $grayButton.innerText = 'HTML배경 회색토글';
            $grayButton.className = 'off';
            $grayButton.onclick = function () {

                if ($grayButton.className === 'off') {
                    document.documentElement.style.backgroundColor = 'gray';
                    $grayButton.className = 'on';
                } else {
                    document.documentElement.style.backgroundColor = '';
                    $grayButton.className = 'off';
                }
            };

            return $grayButton;
        },

        etcFuncBtn: rdoc => {

            let $etcFuncBtn = rdoc.createElement('img');
            $etcFuncBtn.title = global.achecker.i18n.get("etcFuncButtonDesc");
            $etcFuncBtn.alt = global.achecker.i18n.get("etcFuncButtonDesc");
            $etcFuncBtn.id = 'etcFuncBtn';
            $etcFuncBtn.src = "" + chrome.extension.getURL('/images/enable-etc-icon.png') + "";
            $etcFuncBtn.width = "28";
            $etcFuncBtn.height = "25";
            
            $etcFuncBtn.onclick = () => {
                let popup = rdoc.getElementById('attachPopUp');
                if (popup.className === 'popup tagname') {

                    popup.className = 'popup tagname open';
                    popup.style.top = rdoc.getElementById('etcFuncBtn').offsetTop + 30 + 'px';
                    popup.style.left = rdoc.getElementById('etcFuncBtn').offsetLeft + 'px';

                    let item1 = rdoc.getElementById('KWAXpopupItem1');
                    // let item2 = rdoc.getElementById('KWAXpopupItem2');
                    // let item3 = rdoc.getElementById('KWAXpopupItem3');

                    item1.onclick = () => {
                        KWAX.func.headingPage(rdoc);
                    }
                    //resolve usage
                    // item2.onclick = () => {
                    //     KWAX.func.attachTagName(rdoc.getElementsByTagName('body')[0], 2);
                    // }
                    // item3.onclick = () => {
                    //     KWAX.func.attachTagName(rdoc.getElementsByTagName('body')[0], 3);
                    // }

                } else {
                    let popup = rdoc.getElementById('attachPopUp');
                    popup.className = 'popup tagname';

                    let array = rdoc.getElementsByClassName('attachtag');
                    while (array.length > 0) {
                        for (let value of array) {
                            value.remove();
                        }
                    }
                }
            }
            return $etcFuncBtn;
        },

        tabFocusBtn: (rdoc) => {

            let $tabFocusBtn = rdoc.createElement('img');
            $tabFocusBtn.title = global.achecker.i18n.get("tabFocusButtonDesc");
            $tabFocusBtn.alt = global.achecker.i18n.get("tabFocusButtonDesc");
            $tabFocusBtn.src = "" + chrome.extension.getURL('/images/disable-tabFocus-icon.png') + "";
            $tabFocusBtn.id = 'tabFocusBtn'
            
            $tabFocusBtn.className = 'tabFocusBtn'

            
//            $tabFocusBtn.width = "42"
  //          $tabFocusBtn.height = "25" ;
//            $tabFocusBtn.maxWidth = "42" ;
            

            
            
            $tabFocusBtn.onclick = () => {
                KWAX.func.onFocusHighlight(rdoc);
                $tabFocusBtn.src = "" + chrome.extension.getURL('/images/enable-tabFocus-icon.png') + ""
                $tabFocusBtn.style.cursor='auto';
                
            }
            return $tabFocusBtn;
        },

        changeLocationBtn: (rdoc) => {
            let $changeLocationBtn = rdoc.createElement('img');
            $changeLocationBtn.title = global.achecker.i18n.get("changeLocationBottomButtonDesc");
            $changeLocationBtn.alt = global.achecker.i18n.get("changeLocationBottomButtonDesc");
            $changeLocationBtn.src = "" + chrome.extension.getURL('/images/left-right-arrow-32.png') + "";
            $changeLocationBtn.onclick = () => {

                let result = rdoc.getElementById('kwax-result');
                let scroll = rdoc.getElementById('resultScroll');
                let html = rdoc.documentElement;
                let cn = result.className;
                if (cn.lastIndexOf('v') === -1) {
                    $changeLocationBtn.src = "" + chrome.extension.getURL('/images/up-down-arrow-32.png') + ""
                    $changeLocationBtn.title = global.achecker.i18n.get("changeLocationLeftButtonDesc");
                    $changeLocationBtn.alt = global.achecker.i18n.get("changeLocationLeftButtonDesc");
                    result.className = 'kwax-result v';
                    scroll.className = 'kwax-result resultScroll v';
                    result.style = '';
                    scroll.style = 'left: 0px';
                    html.style = '';
                    html.className = html.className + ' v';
                } else {
                    $changeLocationBtn.src = "" + chrome.extension.getURL('/images/left-right-arrow-32.png') + ""
                    $changeLocationBtn.title = global.achecker.i18n.get("changeLocationBottomButtonDesc");
                    $changeLocationBtn.alt = global.achecker.i18n.get("changeLocationBottomButtonDesc");
                    result.className = 'kwax-result';
                    scroll.className = 'kwax-result resultScroll';
                    result.style = '';
                    scroll.style = 'left: 700px';
                    html.style = '';
                    html.className = html.className.replace(' v', '');
                }
            }
            return $changeLocationBtn;
        },

        toggleGuideBtn: () => {
            //not use
            let $toggle = document.createElement('button');
            $toggle.className = 'guideon'
            $toggle.innerText = '가이드 숨기기';
            $toggle.onclick = () => {
                if ($toggle.className == 'guideon') {
                    $toggle.parentElement.nextElementSibling.getElementsByTagName('h3')[0].style.display = 'none';
                    $toggle.className = 'guideoff'
                    $toggle.innerText = '가이드 보기';
                } else {
                    $toggle.parentElement.nextElementSibling.getElementsByTagName('h3')[0].style.display = 'block';
                    $toggle.className = 'guideon'
                    $toggle.innerText = '가이드 숨기기';
                }
            }
            return $toggle;
        },

        ignoreCommonAreaBtn: (ignoreCommon) => {
            let container = document.createElement('div');
            let checkBox = document.createElement('input');
            let text = document.createElement('p');
            text.style.fontSize = '13px';
            container.style.display = 'inline-flex';
            container.style.alignItems = 'center';
            container.style.float = 'right';
            checkBox.setAttribute('type', 'checkbox');
            checkBox.checked = ignoreCommon
            //한번 활성화 하면 막음
            if(checkBox.checked){
                // checkBox.disabled = 'true';
                // 02-11 disable이 시각적이지 못해 텍스트만 return
               
               text.innerText = 'KT 공통 영역 제외됨';
               container.appendChild(text);
               return container;
            }
            checkBox.addEventListener('change', function () {
                if (this.checked) {
                    document.body.removeChild(document.getElementById("kwax-result"));
                    document.body.removeChild(document.getElementById("resultScroll"));
                    document.documentElement.className = document.documentElement.className.replace(/ kwax\-included/, '');
                    document.documentElement.style = null;

                    var appId = chrome.extension.getURL('');
                 //   alert("appId=" + appId)     //appId=chrome-extension://hbijehpgocnclhfdllgcckpohelomjmh/
                    var preIndex = appId.indexOf('//') + 2;
                    var postIndex = appId.lastIndexOf('/');
                    appId = appId.substring(preIndex, postIndex);
                 // alert("appId2=" + appId)  //appId=hbijehpgocnclhfdllgcckpohelomjmh
                    chrome.runtime.sendMessage(appId, {
                        ignoreCommon: true
                    }, function (response) {
                        // console.log(response);
                    });
                } else {
                    var appId = chrome.extension.getURL('');
                 //alert("appId=" + appId)
                    var preIndex = appId.indexOf('//') + 2;
                    var postIndex = appId.lastIndexOf('/');
                    appId = appId.substring(preIndex, postIndex);
                 //  alert("appId2=" + appId)
                    chrome.runtime.sendMessage(appId, {
                        ignoreCommon: false
                    }, function (response) {
                        // console.log(response);
                    });
                }
            })
            text.innerText = 'KT 공통영역 제외하기';
            checkBox.className = 'ignorecommon';
            container.appendChild(checkBox);
            container.appendChild(text);
            return container;
        },

        downloadStatisticsXLSX: (rdoc) => {
            let $downloadStatisticsXLSXBtn = rdoc.createElement('img');
            $downloadStatisticsXLSXBtn.title = global.achecker.i18n.get("downloadStatisticsXLSXButtonDesc");
            $downloadStatisticsXLSXBtn.alt = global.achecker.i18n.get("downloadStatisticsXLSXButtonDesc");
            $downloadStatisticsXLSXBtn.src = "" + chrome.extension.getURL('/images/statistics-icon.png') + "";
            $downloadStatisticsXLSXBtn.onclick = () => {
                const loadSheet = new Promise((resolve, reject) => { 
                    chrome.storage.local.get(function(result){
                        let ws = result.excelSheet
                        let cc = result.sheetCurrentCol
                        let co = result.resultCount
                        let to = result.totalCountCol
                        if(!!result){
                            resolve({sheet: ws, col: cc, count: co, to: to});
                        }else{
                            reject(new Error("Fail load Storage"));
                        }
                    });
                });

                loadSheet.then((res)=>{

                    if(!!res.sheet){
                        let data = []; 
                        data.push({A: '대상항목', B: 'ALL', C: 'PASS', D: 'WARNING', E: 'FAIL', F: '결함율', G: '점수' });
                        for(let i=0; i<14; i++){
                            let colAll = res.to['ALL'].join((4+i)+',');
                            let colPass = res.to['PASS'].join((4+i)+',');
                            let colWarn = res.to['WARNING'].join((4+i)+',');
                            let colFail = res.to['FAIL'].join((4+i)+',');
                            data.push({A: title[i], B: {f:'SUM('+colAll+(4+i)+')'}, C: {f:'SUM('+colPass+(4+i)+')'}, D: {f:'SUM('+colWarn+(4+i)+')'}, E: {f:'SUM('+colFail+(4+i)+')'}, F: {f:'IF(E'+(22+i)+'<>0, E'+(22+i)+'/B'+(22+i)+', 0)', z:'0.0%'} });
                        }

                        //02-22 합계점수 추가
                        let totalScore = '=SUM(';
                        let sectionWeights = [30,3,10,15,2,10,10,20];
                        let colNum = 22;
                        for (let i=0; i<sectionWeights.length; i++) {
                                let sectionScore = '';
                                if(colNum == 22){
                                    sectionScore='IF(B22<>0,((B22-E22)+(B24-E24))/(B22+B24) * 30 * 10 / 10,'+sectionWeights[i]+'),';
                                    colNum+=4;
                                }
                                else if(colNum == 28){
                                        sectionScore='IF(B28<>0,((B28-E28)+(B29-E29))/(B28+B29) * 10 * 10 / 10,'+sectionWeights[i]+'),';
                                        colNum+=2;
                                }else{
                                    sectionScore='IF(B'+colNum+'<>0,((B'+colNum+'-E'+colNum+')/B'+colNum+' * '+sectionWeights[i]+' * 10) / 10,'+sectionWeights[i]+'),';
                                }
                                totalScore+=sectionScore;
                                colNum++;
                        }
                        totalScore += ')'

                        data.push({A: '합계', B: {f:'SUM(B22:B35)'}, C: {f:'SUM(C22:C35)'}, D: {f:'SUM(D22:D35)'}, E: {f:'SUM(E22:E35)'}, F: {f:'E36/B36', z:'0.0%'}, G: {f:totalScore} });
                        XLSX.utils.sheet_add_json(res.sheet, data, {skipHeader: true, origin: { r: 20, c: 0 }, header: ['A', 'B', 'C', 'D', 'E', 'F'] });
                        /* create workbook and export */
                        let wb = XLSX.utils.book_new();
                        let date = new Date().toLocaleDateString();
                        XLSX.utils.book_append_sheet(wb, res.sheet, 'K-WAX-Statistics');
                        let sheet = XLSX.write(wb, {type: "base64", bookType: "xlsx"});
                        let zip = new JSZip();
                        
                        let url;
                        zip.file("K-WAX-Statistics-"+date.replace(/.\s+/igm, '-')+"xlsx", sheet, {base64:true});
                        zip.file("000003.log", new Blob([JSON.stringify(wb)], {type:'application/json'}), {binary:true});
                        const waitZip = new Promise((resolve, reject) => { 
                            zip.generateAsync({type:"blob", compression: "DEFLATE", compressionOptions: {level: 4}}).then(function(content){
                                url = window.URL.createObjectURL(content);
                                if(!!url){
                                    resolve(url);
                                }else{
                                    reject(new Error("Fail ZIP Creation"));
                                }
                            })
                        })
                        
                        waitZip.then((data)=>{
                            let appId = chrome.extension.getURL('');
                            let preIndex = appId.indexOf('//') + 2;
                            let postIndex = appId.lastIndexOf('/');
                            appId = appId.substring(preIndex, postIndex);
                            chrome.runtime.sendMessage(appId, {
                                zipDown: "yes",
                                url: data
                            }, function (response) {
                                // console.log(response);
                            });
                        })
                        chrome.storage.local.clear();
                    }else{
                        alert('저장된 페이지 Report가 없습니다. 현재 페이지 Report(Html)를 먼저 저장하신 후 \n통합 통계 Report(Excel) 다운로드 받기를 실행해 주세요. ');
                    }
                })
            }
            return $downloadStatisticsXLSXBtn;
        },
    
        speakBtn: function (rdoc) {
            let $speakBtn = rdoc.createElement('img');
                 //fold 버튼 설정
//            $foldBtn.className = 'fold';
$speakBtn.setAttribute('id', 'speakBtn');
$speakBtn.setAttribute('TTS-onoff', '');
$speakBtn.setAttribute('src', ""+chrome.extension.getURL('/images/speakX.png')+"");
            
            $speakBtn.title = global.achecker.i18n.get('TTSon');
            $speakBtn.alt = global.achecker.i18n.get("TTSon");
            $speakBtn.width = "28"
            $speakBtn.height = "25" ;
            $speakBtn.textContent = 'Toggle All';
            $speakBtn.onclick = function () {

                var $headings = rdoc.querySelectorAll('.waxSection h2,.waxFrames h2');
                ///var foldedClass = this.getAttribute('data-folded') === 'folded' ? '' : 'folded';
                
                var TTSonoff = this.getAttribute('TTS-onoff') === '' ? 'on' : '';

                if (TTSonoff) {  // on 이면
//                  this.className = 'unfold';
                  $speakBtn.title = global.achecker.i18n.get('TTSoff');
                  $speakBtn.alt = global.achecker.i18n.get("TTSoff");
                  this.setAttribute('src', ""+chrome.extension.getURL('/images/speak.png')+"");
//                 chrome.runtime.sendMessage({payload: "play", message: ("케이왁스 TTS 기능 활성화") });
               //   chrome.runtime.sendMessage({payload: "play", message: ("UHD VR") });
//                                    chrome.runtime.sendMessage({payload: "play", message: ("3G 5G 5good acer ADIDAS AI Airpods apple Basic best blog CJ Classic Copyright egg facebook FAQ FITT Fold Galaxy GB GIGA HAAN HP Https idea instergram Iot ipad ") });
//                  chrome.runtime.sendMessage({payload: "play", message: ("pro shop small SMS special spigen START Stripes style super Tel time TV  tweeter UHD TV USIM VAT VIP VR VVIP watch wearable why WIFI youtube 기본 문자50건 15,000알 문자750알 복지 15000요금제") });
//이곳에서 전역변수 active 를 컨틀롤 하게 기능 추가
              
                } else {
//이곳에서 전역변수 active 를 컨틀롤 하게 기능 추가

                    //                  this.className = 'fold';
                  $speakBtn.title = global.achecker.i18n.get('TTSon');
                  $speakBtn.alt = global.achecker.i18n.get("TTSon");
                  this.setAttribute('src', ""+chrome.extension.getURL('/images/speakX.png')+"");
  //                chrome.runtime.sendMessage({payload: "play", message: "케이왁스 TTS 기능 비활성화"});
//                  chrome.runtime.sendMessage({payload: "play", message: "iphone JVC Large LED TV LG LTE mAh MAX MB mbps medium mobile my Nike olleh on people Technology PICO pop post "});
//chrome.runtime.sendMessage({payload: "play", message: "mAh MAX MB mbps medium mobile my Nike olleh on people Technology PICO pop post "});
                }
                this.setAttribute('TTS-onoff', TTSonoff);
                // fix bug: IE8 won't reflow when set data-* attribute
                //rdoc.body.className = rdoc.body.getAttribute("className");
            };
    
            return $speakBtn;
            },
    
        hiddenInputBtn: (rdoc) => {
            let container = rdoc.createElement('div');
            let hiddenInput = rdoc.createElement('input');
            let hiddenInputLabel = rdoc.createElement('label');
            hiddenInput.id = "hiddenupload";
            hiddenInput.style = "display: none;";
            hiddenInput.type = "file";
            hiddenInputLabel.setAttribute('for', 'hiddenupload');
            hiddenInputLabel.style = "position: absolute; width: 5px; height: 5px; right: 100%; top: 1%; cursor: pointer; color: #ffffff00;"
            hiddenInputLabel.textContent = "　"; // special character ㄱ + 한자 + 1
            hiddenInput.onchange = (e) => {

                let files = e.target.files, f = files[0];
                let reader = new FileReader();
                reader.readAsText(f,'UTF-8');
                reader.onload = function(e) {
                  let data = e.target.result;
                  data = JSON.parse(data);
                    XLSX.writeFile(data, "Decode-result.xlsx");
                  /* DO SOMETHING WITH workbook HERE */
                };
            }
            container.appendChild(hiddenInput);
            container.appendChild(hiddenInputLabel);
            return container;
        }
    }

    KWAX.func = {

        content: document.createElement("canvas"),
        data: '',

        getBase64: function (self) {
            var img = new Image();
            var dataURL = '';
            img.onload = function () {
                img.crossOrigin = 'Anonymous';
                let canvas = document.createElement("canvas");
                canvas.width = img.width;
                canvas.height = img.height;
                let ctx = canvas.getContext("2d");
                ctx.drawImage(img, 0, 0);
                dataURL = canvas.toDataURL("image/png");
            }
            img.src = self.src;
            return dataURL;
        },

        dataURItoBlob: function (dataURI) {
            // convert base64 to raw binary data held in a string
            var byteString = atob(dataURI.split(',')[1]);

            // separate out the mime component
            var mimeString = dataURI.split(',')[0].split(':')[1].split(';')[0];

            // write the bytes of the string to an ArrayBuffer
            var arrayBuffer = new ArrayBuffer(byteString.length);
            var _ia = new Uint8Array(arrayBuffer);
            for (var i = 0; i < byteString.length; i++) {
                _ia[i] = byteString.charCodeAt(i);
            }

            var dataView = new DataView(arrayBuffer);
            var blob = new Blob([dataView], {
                type: mimeString
            });
            return blob;
        },

        getDownloadImgElement: function (rdoc, self, src, url, doc, getAbsolutePath) {
            var $download = rdoc.createElement('a');
            if (src === null || src === undefined) return $download;
            $download.setAttribute('href', src);
            $download.download = src.substring(src.lastIndexOf("/") + 1).split("?")[0];
            $download.setAttribute('target', '_blank');
            $download.setAttribute('type', 'image/png');

            return $download;
        },

        getDownloadBGUrl: function (rdoc, url) {
            let $download = rdoc.createElement('a');
            $download.setAttribute('href', url);
            $download.download = url.substring(url.lastIndexOf("/") + 1).split("?")[0];
            $download.setAttribute('target', '_blank');
            $download.setAttribute('type', 'image/png');

            return $download;
        },

        getGuide: function (doc, self, i18nString) {
            var $guideContainer = doc.createElement('div');
            $guideContainer.className = 'guide container';
            var guideFullText;
            if (self.title) {
                guideFullText = global.achecker.i18n.get('No' + self.title.substring(0, self.title.indexOf('.')) + 'SolvePropose');
            } else {
                guideFullText = i18nString;
            }
            var arrGuide = guideFullText.split('◈');
            for (let i = 0; i < arrGuide.length; i++) {

                if (arrGuide[i] == '' || arrGuide[i] == undefined) continue;

                let $guideDetailDl = doc.createElement('dl');
                $guideDetailDl.innerHTML = '<span><svg style="width: 20px; height: 48px; overflow: inherit;"><circle cx="5" cy="13" r="6" stroke="red" stroke-width="3" fill="none"></circle></svg></span>';
                let splitExam = arrGuide[i].split('%');

                let $guideDetailDt = doc.createElement('dt');
                let $guideDetailDd = doc.createElement('dd');

                $guideDetailDt.innerText = (splitExam[0] === undefined ? "" : splitExam[0]);
                $guideDetailDd.innerText = (splitExam[1] === undefined ? "" : splitExam[1]);

                if ($guideDetailDt.innerText !== "") {
                    $guideDetailDl.appendChild($guideDetailDt);
                }
                if ($guideDetailDd.innerText !== "") {
                    $guideDetailDl.appendChild($guideDetailDd);
                }

                $guideContainer.appendChild($guideDetailDl);
            }

            return $guideContainer;
        },

        createCaptureImg: function (sendResponse) {

            chrome.tabs.captureVisibleTab(
                null, {
                    format: "png",
                    quality: 100
                },
                function (dataUrl) {
                    sendResponse({
                        farewell: dataUrl
                    });
                }
            );
            return true;
        },

        highlightElement: function (element) {
            var elHTML = document.documentElement;
            var elHTMLStyle = elHTML.getAttribute('class');
            var elResult = document.getElementById('kwax-result');
            var resultScroll = document.getElementById('resultScroll');

            function setIntervalX(callback, delay, repetitions) {
                var x = 0;
                var intervalID = window.setInterval(function () {

                    callback();

                    if (++x === repetitions) {
                        window.clearInterval(intervalID);
                    }
                }, delay);
            }

            elHTML.style.marginLeft = 0;
            elResult.setAttribute('style', 'display: none');
            resultScroll.setAttribute('style', 'display: none');

            setIntervalX(function () {
                element.style.border = '4px dashed red';
            }, 500, 6);

            setIntervalX(function () {
                element.style.border = '';
            }, 1000, 6);

            setTimeout(function () {
                elResult.setAttribute('style', '');
                resultScroll.setAttribute('style', '');
                elHTML.style.marginLeft = elResult.style.width;
            }, 4000);

        },

        onFocusHighlight: function (doc) {
            var allElements = doc.body.getElementsByTagName("*");
            var prevBorder = '';
            for (let i = 0; i < allElements.length; i++) {

                prevBorder = allElements[i].style.border;

                allElements[i].onfocus = function () {
                    allElements[i].style.border = '4px dashed red';
                };
                allElements[i].onblur = function () {
                    allElements[i].style.border = prevBorder;
                };
            }
        },

        countData: function (waxSections) {
            var allContents = 0;
            var passContents = 0;
            var failContents = 0;
            var scoreData;

            for (var i in waxSections) {
                scoreData = waxSections[i].getScore();
                if (scoreData) {
                    allContents += scoreData.all;
                    passContents += scoreData.pass;
                    failContents += scoreData.fail;
                }
            }
            return {
                all: allContents,
                pass: passContents,
                fail: failContents
            }
        },

        attachTagName: (el, itemId) => {
            const element_list = (el, itemId) => {
                const rdoc = document;
                for (var i = 0; i < el.children.length; i++) {

                    let id = el.children[i].id + '';
                    let className = el.children[i].class + '';

                    const ignoreElementAttr = ['kwax-result', 'wax'];
                    let isCheckElement = [];

                    if (itemId === 1) isCheckElement = ['h1', 'h2', 'h3', 'h4', 'h5', 'h6'];
                    else if (itemId === 2) isCheckElement = ['ul', 'li'];

                    if (ignoreElementAttr.includes(id, className.substring(0, 3))) continue;

                    let tagName = el.children[i].tagName;
                    tagName = tagName.toLowerCase();

                    if (tagName !== 'script' && isCheckElement.includes(tagName)) {
                        let text = el.children[i].text;
                        let prevSpanTag = rdoc.createElement('span');
                        let postSpanTag = rdoc.createElement('span');
                        let contentSpanTag = rdoc.createElement('span');

                        let spanStyle = `background: rgb(255, 239, 213); 
                                        padding: 1px; 
                                        border: 1px solid rgb(0, 0, 128); 
                                        border-image: none; color: 
                                        rgb(0, 0, 128); 
                                        font-family: 'Noto Sans KR', sans-serif;
                                        font-size: x-small; 
                                        font-weight: bold; 
                                        display: inline; 
                                        position: relative; 
                                        z-index: 10000;`;

                        prevSpanTag.style = spanStyle;
                        postSpanTag.style = spanStyle;
                        contentSpanTag.style = spanStyle;

                        prevSpanTag.className = 'attachtag';
                        postSpanTag.className = 'attachtag';
                        contentSpanTag.className = 'attachtag';

                        let strongTag1 = rdoc.createElement('strong');
                        let strongTag2 = rdoc.createElement('strong');

                        //special charracter < > not shift+, shift+. 
                        let prevTagName = '＜' + tagName + '＞';
                        let postTagName = '＜/' + tagName + '＞';

                        strongTag1.textContent = prevTagName;
                        strongTag2.textContent = postTagName;
                        contentSpanTag.textContent = text;

                        prevSpanTag.appendChild(strongTag1);
                        postSpanTag.appendChild(strongTag2);

                        el.children[i].insertBefore(prevSpanTag, el.children[i].children[0]);
                        if (tagName.substring(0, 1) === 'h') {
                            el.children[i].appendChild(contentSpanTag);
                        }
                        el.children[i].appendChild(postSpanTag);
                    }
                    element_list(el.children[i], itemId);
                }
            }
            element_list(el, itemId);
        },

        headingPage: (rdoc) => {

            const bodyElements = rdoc.querySelectorAll("body>*:not(#kwax-result):not(script)");
            let headingElements = [];
            for (let bodyElement of bodyElements) {
                headingElements = headingElements.concat(Array.prototype.slice.call(bodyElement.querySelectorAll("h1, h2, h3, h4, h5, h6")));
            }
            for (let i of bodyElements) {
                i.remove();
            }

            //back to page anchor
            let backToPage = rdoc.createElement('a');
            backToPage.text = '<- Back To Page';
            backToPage.style = `color: blue; cursor: pointer;`;
            backToPage.onclick = () => {
                location.reload();
            };
            rdoc.body.appendChild(backToPage);

            for (let hElement of headingElements) {
                let outerHTML = hElement.outerHTML;
                let startTag = outerHTML.substring(0, outerHTML.lastIndexOf('>') - 4);
                let endTag = outerHTML.substring(outerHTML.lastIndexOf('>') - 4);
                let tagSpace = 40 * parseInt(hElement.tagName.substring(1));

                let divContainer = rdoc.createElement('div');
                let spanContainer = rdoc.createElement('span');
                let tempSpan = rdoc.createElement('span');
                let hContainer = rdoc.createElement(hElement.tagName.toLowerCase());


                divContainer.style = `font-family: 'Noto Sans KR', sans-serif; margin-left: ${tagSpace}px; font-size-adjust: none; font-stretch: normal; color: rgb(0, 0, 128);`;
                spanContainer.style = 'font-family: verdana; color: rgb(0, 0, 128);';
                tempSpan.style = 'color: rgb(0, 0, 128);';
                hContainer.style = 'color: rgb(0, 0, 128)';
                tempSpan.textContent = endTag;

                hContainer.textContent = startTag;
                hContainer.appendChild(tempSpan);
                spanContainer.appendChild(hContainer);
                divContainer.appendChild(spanContainer);

                rdoc.body.appendChild(divContainer);
            }
        },

        resizeEventInit: () => {
            window.kwaxElement = document.getElementById('kwax-result');
            window.resultScroll = document.getElementById('resultScroll');
        },

        kwaxMouseDown: (e) => {
            isResizing = true;
        },
        kwaxMouseMove: (e) => {
            if (!isResizing) return;
            let cn = kwaxElement.className;
            if (cn.lastIndexOf('v') === -1) {
                let offsetRight = kwaxElement.offsetWidth - e.clientX;
                kwaxElement.style.width = (kwaxElement.offsetWidth - offsetRight) + 'px';
                document.documentElement.style.marginLeft = kwaxElement.style.width;
                resultScroll.style.left = kwaxElement.style.width;
            } else {
                kwaxElement.style.top = e.clientY + 'px';
                if ((document.documentElement.clientHeight - e.clientY) > 0) {
                    resultScroll.style.top = (e.clientY - 10) + 'px';
                }
                kwaxElement.style.height = (40 + (60 - (e.clientY / document.documentElement.clientHeight * 100))) + '%';
            }
        },
        kwaxMouseUp: (e) => {
            isResizing = false;
        },
        kwaxDblclick: () => {
            let cn = kwaxElement.className;
            if (cn.lastIndexOf('v') === -1) {
                kwaxElement.style.width = '700px';
                document.documentElement.style.marginLeft = '700px';
                resultScroll.style.left = '700px';
            } else {
                kwaxElement.style.top = '60%';
                kwaxElement.style.height = '40%';
                resultScroll.style.top = '59%';
                resultScroll.style.left = '0px';
            }
        },
        addResizeEvent: () => {
            resultScroll.addEventListener("mousedown", KWAX.func.kwaxMouseDown, true);
            resultScroll.addEventListener("dblclick", KWAX.func.kwaxDblclick, true);
            window.addEventListener("mousemove", KWAX.func.kwaxMouseMove, true);
            window.addEventListener("mouseup", KWAX.func.kwaxMouseUp, true);
        },

        magnifyDocument: () => {
            let magnifier = document.createElement('div');
            magnifier.class = 'kwax-magnifier';
            magnifier.id = 'kwax-magnifier';

            let appId = chrome.extension.getURL('');
            let preIndex = appId.indexOf('//') + 2;
            let postIndex = appId.lastIndexOf('/');
            appId = appId.substring(preIndex, postIndex);
            let captureData = window.captureData;
            let getData = () => {};
            if (!captureData) {
                getData = () => {
                    return new Promise((resolve, reject) => {
                        chrome.runtime.sendMessage(
                            appId, {
                                capture: "yes",
                            },
                            function (response) {
                                if (!response) {
                                    // console.log("not receive");
                                    return;
                                } else {
                                    // console.log(blob);
                                    captureData = response.src;
                                    dataURI = response.src;

                                }
                                if (response) {
                                    resolve(captureData);
                                }
                                reject(new Error("Request is failed"));
                            });
                    });
                }
            }

            getData().then(function (data) {
                let myURL = window.URL || window.webksitURL;
                magnifier.style.backgroundImage = 'url("' + data + '")';
                magnifier.style.backgroundRepeat = 'no-repeat';
                //set magnification 3
                magnifier.style.backgroundSize = (window.innerWidth * 3) + 'px ' + (window.innerHeight * 3) + 'px';

                magnifier.style.left = '';
                magnifier.style.top = '';
                magnifier.style.backgroundPosition = '';
            }).catch(function (err) {
                console.error(err);
            });


            return magnifier;
        },

        moveMagnifier: (e) => {

            let x = e.pageX;
            let y = e.pageY;

            /*consider any page scrolling:*/
            x = x - window.pageXOffset;
            y = y - window.pageYOffset;
            let magnifier = achecker.colorInspector.magnifier;
            let bw = 3;
            let w = magnifier.offsetWidth / 2;
            let h = magnifier.offsetHeight / 2;
            let zoom = 3;

            let docEl = document.documentElement;
            if (x > docEl.clientWidth - (w / zoom)) {
                x = docEl.clientWidth - (w / zoom);
            }
            if (x < w / zoom) {
                x = w / zoom;
            }
            if (y > docEl.clientHeight - (h / zoom)) {
                y = docEl.clientHeight - (h / zoom);
            }
            if (y < h / zoom) {
                y = h / zoom;
            }

            magnifier.style.left = (x - w) + "px";
            magnifier.style.top = (y - h) + "px";
            magnifier.style.backgroundPosition = "-" + ((x * zoom) - w + bw) + "px -" + ((y * zoom) - h + bw) + "px";
        }, 
        bxsliderFiX: function () {
        //* target page & K-WAX 충돌 처리
        // 2019.07.23 shop bx-slider 예외처리하기
        if (document.querySelector('#NewSub > div > div.halfMainTop > div > div.bx-viewport') != null) 
          {
            document.querySelector('#NewSub > div > div.halfMainTop > div > div.bx-viewport').style.maxHeight="350px";
          }
        }
    }

}(this));